changelog shortlog graph tags branches changeset files revisions annotate raw help

Mercurial > infra / bootstrap.sh

changeset 261: e51101c3c83c
parent: c5aa261cb836
child: 8015880d9a0d
author: Richard Westhaver <ellis@rwest.io>
date: Sat, 15 Jun 2024 22:32:08 +0000
permissions: -rwxr-xr-x
description: bootstrap updates
1 #!/bin/sh
2 set -eu
3 
4 main() {
5  . ./check.sh
6  download --check
7  local _arch=$(_read arch | tr -d '"')
8  local _ext=""
9  case "$_arch" in
10  *windows*)
11  _ext=".exe"
12  ;;
13  esac
14  local _url="https://packy.compiler.company/dist/${_arch}/pack"
15  local _stash
16  if ! _stash=".stash"; then
17  # Because the previous command ran in a subshell, we must manually
18  # propagate exit status.
19  exit 1
20  fi
21  ensure mkdir -p "${_stash}/src"
22  ensure mkdir -p "${_stash}/share/lisp/fasl"
23  ensure mkdir -p "${_stash}/bin"
24  ensure mkdir -p "${_stash}/lib"
25  ensure mkdir -p "${_stash}/include"
26  cd "${_stash}"
27  local _sbcl_pack="sbcl.tar.zst"
28  local _rocksdb_pack="rocksdb.tar.zst"
29  local _core_pack="core.tar.zst"
30  local _core_src_pack="core-source.tar.zst"
31  local _sbcl_url="${_url}/${_sbcl_pack}"
32  local _rocksdb_url="${_url}/${_rocksdb_pack}"
33  local _core_url="${_url}/${_core_pack}"
34  local _core_src_url="${_url}/${_core_src_pack}"
35  ensure download "$_sbcl_url" "$_sbcl_pack" "$_arch"
36  unzstd "${_sbcl_pack}"
37  tar -xvf "sbcl.tar"
38  cd sbcl && INSTALL_ROOT=$(realpath ..) sh install.sh && cd ..
39  ensure download "$_core_src_url" "$_core_src_pack" "$_arch"
40  unzstd "${_core_src_pack}"
41  tar -xvf "core-source.tar"
42  mv core src/
43  # ensure download "$_rocksdb_url" "${_rocksdb_pack}" "$_arch"
44  # unzstd "${_rocksdb_pack}"
45  # tar -xvf "pack/rocksdb.tar"
46  # cp -rf rocksdb/include/* include/
47  # cp -rf rocksdb/*.so lib/
48  ensure download "$_core_url" "${_core_pack}" "$_arch"
49  unzstd "${_core_pack}"
50  tar -xvf "core.tar"
51  cp -rf core/bin/* bin/
52  cp -rf core/share/* share/
53  chmod +x bin/*
54  rm -rf core sbcl
55  rm -rf *.tar
56 }
57 
58 _read() {
59  grep ":$1" $INFRA_HOST_CONFIG | cut -d' ' -f 2-
60 }
61 
62 # Check if curl supports the --retry flag, then pass it to the curl invocation.
63 check_curl_for_retry_support() {
64  local _retry_supported=""
65  # "unspecified" is for arch, allows for possibility old OS using macports, homebrew, etc.
66  if check_help_for "notspecified" "curl" "--retry"; then
67  _retry_supported="--retry 3"
68  if check_help_for "notspecified" "curl" "--continue-at"; then
69  # "-C -" tells curl to automatically find where to resume the download when retrying.
70  _retry_supported="--retry 3 -C -"
71  fi
72  fi
73 
74  RETVAL="$_retry_supported"
75 }
76 
77 # Return cipher suite string specified by user, otherwise return strong TLS 1.2-1.3 cipher suites
78 # if support by local tools is detected. Detection currently supports these curl backends:
79 # GnuTLS and OpenSSL (possibly also LibreSSL and BoringSSL). Return value can be empty.
80 get_ciphersuites_for_curl() {
81  if [ -n "${TLS_CIPHERSUITES-}" ]; then
82  # user specified custom cipher suites, assume they know what they're doing
83  RETVAL="$TLS_CIPHERSUITES"
84  return
85  fi
86 
87  local _openssl_syntax="no"
88  local _gnutls_syntax="no"
89  local _backend_supported="yes"
90  if curl -V | grep -q ' OpenSSL/'; then
91  _openssl_syntax="yes"
92  elif curl -V | grep -iq ' LibreSSL/'; then
93  _openssl_syntax="yes"
94  elif curl -V | grep -iq ' BoringSSL/'; then
95  _openssl_syntax="yes"
96  elif curl -V | grep -iq ' GnuTLS/'; then
97  _gnutls_syntax="yes"
98  else
99  _backend_supported="no"
100  fi
101 
102  local _args_supported="no"
103  if [ "$_backend_supported" = "yes" ]; then
104  # "unspecified" is for arch, allows for possibility old OS using macports, homebrew, etc.
105  if check_help_for "notspecified" "curl" "--tlsv1.2" "--ciphers" "--proto"; then
106  _args_supported="yes"
107  fi
108  fi
109 
110  local _cs=""
111  if [ "$_args_supported" = "yes" ]; then
112  if [ "$_openssl_syntax" = "yes" ]; then
113  _cs=$(get_strong_ciphersuites_for "openssl")
114  elif [ "$_gnutls_syntax" = "yes" ]; then
115  _cs=$(get_strong_ciphersuites_for "gnutls")
116  fi
117  fi
118 
119  RETVAL="$_cs"
120 }
121 
122 # Return cipher suite string specified by user, otherwise return strong TLS 1.2-1.3 cipher suites
123 # if support by local tools is detected. Detection currently supports these wget backends:
124 # GnuTLS and OpenSSL (possibly also LibreSSL and BoringSSL). Return value can be empty.
125 get_ciphersuites_for_wget() {
126  if [ -n "${TLS_CIPHERSUITES-}" ]; then
127  # user specified custom cipher suites, assume they know what they're doing
128  RETVAL="$TLS_CIPHERSUITES"
129  return
130  fi
131 
132  local _cs=""
133  if wget -V | grep -q '\-DHAVE_LIBSSL'; then
134  # "unspecified" is for arch, allows for possibility old OS using macports, homebrew, etc.
135  if check_help_for "notspecified" "wget" "TLSv1_2" "--ciphers" "--https-only" "--secure-protocol"; then
136  _cs=$(get_strong_ciphersuites_for "openssl")
137  fi
138  elif wget -V | grep -q '\-DHAVE_LIBGNUTLS'; then
139  # "unspecified" is for arch, allows for possibility old OS using macports, homebrew, etc.
140  if check_help_for "notspecified" "wget" "TLSv1_2" "--ciphers" "--https-only" "--secure-protocol"; then
141  _cs=$(get_strong_ciphersuites_for "gnutls")
142  fi
143  fi
144 
145  RETVAL="$_cs"
146 }
147 
148 check_help_for() {
149  local _arch
150  local _cmd
151  local _arg
152  _arch="$1"
153  shift
154  _cmd="$1"
155  shift
156 
157  local _category
158  if "$_cmd" --help | grep -q 'For all options use the manual or "--help all".'; then
159  _category="all"
160  else
161  _category=""
162  fi
163 
164  case "$_arch" in
165 
166  *darwin*)
167  if check_cmd sw_vers; then
168  case $(sw_vers -productVersion) in
169  10.*)
170  # If we're running on macOS, older than 10.13, then we always
171  # fail to find these options to force fallback
172  if [ "$(sw_vers -productVersion | cut -d. -f2)" -lt 13 ]; then
173  # Older than 10.13
174  echo "Warning: Detected macOS platform older than 10.13"
175  return 1
176  fi
177  ;;
178  11.*)
179  # We assume Big Sur will be OK for now
180  ;;
181  *)
182  # Unknown product version, warn and continue
183  echo "Warning: Detected unknown macOS major version: $(sw_vers -productVersion)"
184  echo "Warning TLS capabilities detection may fail"
185  ;;
186  esac
187  fi
188  ;;
189 
190  esac
191 
192  for _arg in "$@"; do
193  if ! "$_cmd" --help "$_category" | grep -q -- "$_arg"; then
194  return 1
195  fi
196  done
197 
198  true # not strictly needed
199 }
200 
201 # Return strong TLS 1.2-1.3 cipher suites in OpenSSL or GnuTLS syntax. TLS 1.2
202 # excludes non-ECDHE and non-AEAD cipher suites. DHE is excluded due to bad
203 # DH params often found on servers (see RFC 7919). Sequence matches or is
204 # similar to Firefox 68 ESR with weak cipher suites disabled via about:config.
205 # $1 must be openssl or gnutls.
206 get_strong_ciphersuites_for() {
207  if [ "$1" = "openssl" ]; then
208  # OpenSSL is forgiving of unknown values, no problems with TLS 1.3 values on versions that don't support it yet.
209  echo "TLS_AES_128_GCM_SHA256:TLS_CHACHA20_POLY1305_SHA256:TLS_AES_256_GCM_SHA384:ECDHE-ECDSA-AES128-GCM-SHA256:ECDHE-RSA-AES128-GCM-SHA256:ECDHE-ECDSA-CHACHA20-POLY1305:ECDHE-RSA-CHACHA20-POLY1305:ECDHE-ECDSA-AES256-GCM-SHA384:ECDHE-RSA-AES256-GCM-SHA384"
210  elif [ "$1" = "gnutls" ]; then
211  # GnuTLS isn't forgiving of unknown values, so this may require a GnuTLS version that supports TLS 1.3 even if wget doesn't.
212  # Begin with SECURE128 (and higher) then remove/add to build cipher suites. Produces same 9 cipher suites as OpenSSL but in slightly different order.
213  echo "SECURE128:-VERS-SSL3.0:-VERS-TLS1.0:-VERS-TLS1.1:-VERS-DTLS-ALL:-CIPHER-ALL:-MAC-ALL:-KX-ALL:+AEAD:+ECDHE-ECDSA:+ECDHE-RSA:+AES-128-GCM:+CHACHA20-POLY1305:+AES-256-GCM"
214  fi
215 }
216 
217 # This wraps curl or wget. Try curl first, if not installed,
218 # use wget instead.
219 download() {
220  local _dld
221  local _ciphersuites
222  local _err
223  local _status
224  local _retry
225  if check_cmd curl; then
226  _dld=curl
227  elif check_cmd wget; then
228  _dld=wget
229  else
230  _dld='curl or wget' # to be used in error message of need_cmd
231  fi
232 
233  if [ "$1" = --check ]; then
234  need_cmd "$_dld"
235  elif [ "$_dld" = curl ]; then
236  check_curl_for_retry_support
237  _retry="$RETVAL"
238  get_ciphersuites_for_curl
239  _ciphersuites="$RETVAL"
240  if [ -n "$_ciphersuites" ]; then
241  _err=$(curl $_retry --proto '=https' --tlsv1.2 --ciphers "$_ciphersuites" --silent --show-error --fail --location "$1" --output "$2" 2>&1)
242  _status=$?
243  else
244  echo "Warning: Not enforcing strong cipher suites for TLS, this is potentially less secure"
245  if ! check_help_for "$3" curl --proto --tlsv1.2; then
246  echo "Warning: Not enforcing TLS v1.2, this is potentially less secure"
247  _err=$(curl $_retry --silent --show-error --fail --location "$1" --output "$2" 2>&1)
248  _status=$?
249  else
250  _err=$(curl $_retry --proto '=https' --tlsv1.2 --silent --show-error --fail --location "$1" --output "$2" 2>&1)
251  _status=$?
252  fi
253  fi
254  if [ -n "$_err" ]; then
255  echo "$_err" >&2
256  if echo "$_err" | grep -q 404$; then
257  err "installer for platform '$3' not found, this may be unsupported"
258  fi
259  fi
260  return $_status
261  elif [ "$_dld" = wget ]; then
262  if [ "$(wget -V 2>&1|head -2|tail -1|cut -f1 -d" ")" = "BusyBox" ]; then
263  echo "Warning: using the BusyBox version of wget. Not enforcing strong cipher suites for TLS or TLS v1.2, this is potentially less secure"
264  _err=$(wget "$1" -O "$2" 2>&1)
265  _status=$?
266  else
267  get_ciphersuites_for_wget
268  _ciphersuites="$RETVAL"
269  if [ -n "$_ciphersuites" ]; then
270  _err=$(wget --https-only --secure-protocol=TLSv1_2 --ciphers "$_ciphersuites" "$1" -O "$2" 2>&1)
271  _status=$?
272  else
273  echo "Warning: Not enforcing strong cipher suites for TLS, this is potentially less secure"
274  if ! check_help_for "$3" wget --https-only --secure-protocol; then
275  echo "Warning: Not enforcing TLS v1.2, this is potentially less secure"
276  _err=$(wget "$1" -O "$2" 2>&1)
277  _status=$?
278  else
279  _err=$(wget --https-only --secure-protocol=TLSv1_2 "$1" -O "$2" 2>&1)
280  _status=$?
281  fi
282  fi
283  fi
284  if [ -n "$_err" ]; then
285  echo "$_err" >&2
286  if echo "$_err" | grep -q ' 404 Not Found$'; then
287  err "installer for platform '$3' not found, this may be unsupported"
288  fi
289  fi
290  return $_status
291  else
292  err "Unknown downloader" # should not reach here
293  fi
294 }
295 
296 main "$@" || exit 1